<template>
    <div class="text-xs-center">
        <v-menu offset-y v-if="languages.length" :title="title">
            <v-btn color="primary" icon slot="activator">
                <v-icon>{{icon}}</v-icon>
            </v-btn>
            <v-list>
                <v-list-tile v-for="lang in languages" :key="lang.id" v-model="lang.active" @click="select(lang)">
                    <v-list-tile-title :title="lang.title">
                        <span :class="lang.icon"></span>
                        {{lang.text}}
                    </v-list-tile-title>
                </v-list-tile>
            </v-list>
        </v-menu>
    </div>
</template>

<script>
    import {url} from "../helpers";
    import Config from "../services/Config";

    export default {
        data: () => ({
            languages: [],
            current: null
        }),

        props: {
            icon: {
                type: String,
                default: 'language'
            },
            title: {
                type: String,
                default: 'Language'
            }
        },

        created() {
            let current = Config.get('language', []);
            this.current = current;

            this.languages = Config.get('languages', []).map(item => {
                const id = typeof item === 'string' ? item : item.id;
                return {
                    id: id,
                    text: item.text || id.toUpperCase(),
                    title: item.title,
                    icon: 'flag-icon flag-icon-' + id,
                    active: id === current
                }
            });
        },

        methods: {
            select(lang) {
                if (lang.id === this.current) {
                    return;
                }

                this.current = lang.id;

                for (let i in this.languages) {
                    this.languages[i].active = lang.id === this.languages[i].id;
                }

                let to = url('?_lang=' + lang.id, true);
                const path = app.$route ? app.$route.path : null;

                if (path) {
                    to += '&_path=' + encodeURIComponent('#' + path);
                }

                location.replace(to);
            }
        }
    }
</script>
